Bug 754185 - Review Request: mingw-p11-kit - MinGW package for p11-kit
Summary: Review Request: mingw-p11-kit - MinGW package for p11-kit
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Erik van Pienbroek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-11-15 16:24 UTC by Michael Cronenworth
Modified: 2011-11-28 14:48 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-11-28 14:48:02 UTC
erik-fedora: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Michael Cronenworth 2011-11-15 16:24:07 UTC
Spec URL: http://michael.cronenworth.com/RPMS/mingw32-p11-kit.spec
SRPM URL: http://michael.cronenworth.com/RPMS/mingw32-p11-kit-0.9-1.fc15.src.rpm
Description: This is the MinGW package for the p11-kit library that already exists in Fedora native. This library recently added support for building under MinGW and is necessary for additional functionality in the GnuTLS library.

Comment 1 Erik van Pienbroek 2011-11-15 17:33:34 UTC
Hi Michael,

Here are some initial review remarks:
- The following lines can be dropped (because of the automatic RPM 4.9 dependency magic) :
  %global _use_internal_dependency_generator 0
  %global __find_requires %{_mingw32_findrequires}
  %global __find_provides %{_mingw32_findprovides}
- Why have you added manual Requires tags for mingw32-gettext and mingw32-iconv? Dependencies should normally be handled by the automatic RPM 4.9 dependency magic so you shouldn't need to provide manual Requires tags here
- Is regenerating the configure script and Makefiles using the autotools/libtool really necessary?
- Is the PATH override in the %build section really needed?
- The line 'rm -rf $RPM_BUILD_ROOT' from the %install section, the entire %clean section and the %defattr line can be removed as modern RPM doesn't require it anymore
- The folder %{_mingw32_sysconfdir}/pkcs11 is currently un-owned. Please add a '%dir %{_mingw32_sysconfdir}/pkcs11' to the %files section

Comment 2 Michael Cronenworth 2011-11-15 17:48:15 UTC
(In reply to comment #1)
> Hi Michael,
> 
> Here are some initial review remarks:
> - The following lines can be dropped (because of the automatic RPM 4.9
> dependency magic) :
>   %global _use_internal_dependency_generator 0
>   %global __find_requires %{_mingw32_findrequires}
>   %global __find_provides %{_mingw32_findprovides}

Good to know.

> - Why have you added manual Requires tags for mingw32-gettext and
> mingw32-iconv? Dependencies should normally be handled by the automatic RPM 4.9
> dependency magic so you shouldn't need to provide manual Requires tags here

This is my fault. I was copying files to my Windows host and noted I needed libintl-8.dll and made a note of it in the spec.

> - Is regenerating the configure script and Makefiles using the
> autotools/libtool really necessary?

Old cruft undoubtedly. Gone.

> - Is the PATH override in the %build section really needed?

Nope.

> - The line 'rm -rf $RPM_BUILD_ROOT' from the %install section, the entire
> %clean section and the %defattr line can be removed as modern RPM doesn't
> require it anymore
> - The folder %{_mingw32_sysconfdir}/pkcs11 is currently un-owned. Please add a
> '%dir %{_mingw32_sysconfdir}/pkcs11' to the %files section

Good catch.

New spec: http://michael.cronenworth.com/RPMS/mingw32-p11-kit.spec
New SRPM: http://michael.cronenworth.com/RPMS/mingw32-p11-kit-0.9-2.fc15.src.rpm

Comment 3 Kalev Lember 2011-11-15 20:24:53 UTC
Good work with packaging it up!

One thing I'd change here is the source package name. Right now Fedora only has the 32 bit MinGW cross toolchain, but we're planning to also add the 64 bit toolchain support in the future. The way it's planned is that there would be one source package, producing separate 32 bit and 64 bit binary rpms.

Because of that, the current MinGW guidelines suggest that newly imported packages should name the source package with the mingw- prefix, so you'd have mingw-p11-kit srpm producing mingw32-p11-kit binary rpm:
https://fedoraproject.org/wiki/Packaging/MinGW#Example_Specfile

Comment 5 Michael Cronenworth 2011-11-15 23:03:03 UTC
Updated spec: http://michael.cronenworth.com/RPMS/mingw-p11-kit.spec

-Fixed files section.
-Duped description.

Comment 6 Erik van Pienbroek 2011-11-16 00:55:29 UTC
$ rpmlint mingw-p11-kit.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint mingw-p11-kit-0.9-4.fc16.src.rpm 
mingw-p11-kit.src: W: spelling-error %description -l en_US discoverable -> discover able, discover-able, irrecoverable
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpmlint noarch/mingw32-p11-kit-0.9-4.fc16.noarch.rpm 
mingw32-p11-kit.noarch: W: spelling-error %description -l en_US discoverable -> discover able, discover-able, irrecoverable
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpm --query --requires mingw32-p11-kit
mingw32(kernel32.dll)  
mingw32(libintl-8.dll)  
mingw32(libp11-kit-0.dll)  
mingw32(msvcrt.dll)  
mingw32(shell32.dll)  
mingw32-filesystem  
mingw32-runtime  
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(PayloadIsXz) <= 5.2-1

$ rpm --query --provides mingw32-p11-kit
mingw32(libp11-kit-0.dll)  
mingw32-p11-kit = 0.9-3.fc17

$ rpm --query --fileprovide mingw32-p11-kit
/usr/i686-pc-mingw32/sys-root/mingw/bin/libp11-kit-0.dll	
/usr/i686-pc-mingw32/sys-root/mingw/bin/p11-kit.exe	
/usr/i686-pc-mingw32/sys-root/mingw/etc/pkcs11	
/usr/i686-pc-mingw32/sys-root/mingw/etc/pkcs11/pkcs11.conf.example	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1/p11-kit	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1/p11-kit/p11-kit.h	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1/p11-kit/pin.h	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1/p11-kit/pkcs11.h	
/usr/i686-pc-mingw32/sys-root/mingw/include/p11-kit-1/p11-kit/uri.h	
/usr/i686-pc-mingw32/sys-root/mingw/lib/libp11-kit.dll.a	
/usr/i686-pc-mingw32/sys-root/mingw/lib/libp11-kit.la	
/usr/i686-pc-mingw32/sys-root/mingw/lib/pkgconfig/p11-kit-1.pc	
/usr/share/doc/mingw32-p11-kit-0.9	
/usr/share/doc/mingw32-p11-kit-0.9/COPYING

$ curl --silent http://p11-glue.freedesktop.org/releases/p11-kit-0.9.tar.gz | md5sum
029aa2a3a103e7eb81b4aa731b93539e  -
$ md5sum p11-kit-0.9.tar.gz 
029aa2a3a103e7eb81b4aa731b93539e  p11-kit-0.9.tar.gz


+ OK
! Needs to be looked into
/ Not applicable
* Overridden by MinGW guidelines

[+] Files are installed in /usr/i686-pc-mingw32/sys-root/mingw
[+] BuildRequires: mingw32-filesystem >= xx is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] default strip and objdump commands are overridden with mingw32 specific ones


[+] rpmlint must be run on every package. The output should be posted in the review
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[/] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[/] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[*] MUST: Header files must be in a -devel package.
[/] MUST: Static libraries must be in a -static package.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[/] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[*] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.


You might want enable verbose output during the build by adding the argument "V=1" to the "make" command.
This makes it easier to investigate any future build issues you may encounter.

As we're also making preparations for the introduction of the mingw-w64 toolchain in Fedora
(currently pending on legal approval) I also tested this package with the mingw-w64 toolchain.
A small patch is needed to get this package built with the mingw-w64 toolchain.
You may already send it upstream so they can incorporate it in their next version.
It shouldn't do any harm to already include it in this package for the time being (to make
the transition to mingw-w64 easier), but I'll leave that up to you to decide.
The patch can be found at: http://svn.openftd.org/svn/fedora_cross/mingw-p11-kit/p11-kit-mingw-w64-compatibility.patch

====================================================
 The package mingw-p11-kit is APPROVED by epienbro
====================================================

Comment 7 Michael Cronenworth 2011-11-16 01:45:58 UTC
(In reply to comment #6)
> You might want enable verbose output during the build by adding the argument
> "V=1" to the "make" command.
> This makes it easier to investigate any future build issues you may encounter.

Good idea.

> The patch can be found at:
> http://svn.openftd.org/svn/fedora_cross/mingw-p11-kit/p11-kit-mingw-w64-compatibility.patch

Sent upstream. I'll consider adding it to the package now.
 
> ====================================================
>  The package mingw-p11-kit is APPROVED by epienbro
> ====================================================

Thanks!

Comment 8 Michael Cronenworth 2011-11-16 01:50:05 UTC
New Package SCM Request
=======================
Package Name: mingw-p11-kit
Short Description: MinGW Library for loading and sharing PKCS#11 modules
Owners: mooninite
Branches: f16
InitialCC:

Comment 9 Gwyn Ciesla 2011-11-16 02:55:00 UTC
Git done (by process-git-requests).

Comment 10 Michael Cronenworth 2011-11-28 14:48:02 UTC
Released to F16 and rawhide.


Note You need to log in before you can comment on or make changes to this bug.